
    
      MODULE Schnittstelle2C
      use kernel32
    implicit none
             INTERFACE

          SUBROUTINE TESTVOID ()
            !DEC$ ATTRIBUTES C :: TESTVOID
          END SUBROUTINE TESTVOID

          integer function TestInteger_FORTRAN(nTest)
            !DEC$ ATTRIBUTES C, DECORATE, ALIAS:'TestInteger' :: TestInteger_FORTRAN  
            !DEC$ ATTRIBUTES VALUE :: nTest
            integer nTest
          end function
            
          integer function TestInteger_Rueckgabe(nTest)
            !DEC$ ATTRIBUTES C :: TestInteger_Rueckgabe
            !DEC$ ATTRIBUTES REFERENCE :: nTest
            integer(4) nTest
          end function

          integer function TestChar(nTest)
            !DEC$ ATTRIBUTES C :: TestChar
            !DEC$ ATTRIBUTES REFERENCE :: nTest
            character(*) nTest
          end function

          integer function TestDouble(nTest)
            !DEC$ ATTRIBUTES C :: TestChar
            !DEC$ ATTRIBUTES REFERENCE :: nTest
            double precision nTest
          end function
          
          integer function TestFloat(nTest)
            !DEC$ ATTRIBUTES C :: TestChar
            !DEC$ ATTRIBUTES REFERENCE :: nTest
            real(4) nTest
          end function

         END INTERFACE
         
         pointer (pr1_TESTVOID,TESTVOID)
         pointer (pr1_TestInteger,TestInteger_FORTRAN)
         pointer (pr1_TestInteger_Rueckgabe,TestInteger_Rueckgabe)
         pointer (pr1_TestChar,TestChar)
         pointer (pr1_TestDouble,TestDouble)
         pointer (pr1_TestFloat,TestFloat)

         integer*4 lala
         integer*4 luba
        
        logical  status
        integer :: pDLL
         Integer dummy
         
         
         integer Inty1
         integer Inty2
         character(20) charly         
         Double precision doubly
         real(4) realy
      contains
 
    subroutine meinTest
    ! This library contains all of our own Matlab functions
    pDLL = LoadLibrary("CplusplusDLL.dll"C)
    if (pDLL == 0) then
      type *, "Error occurred opening the DLL"
      type *, "Program aborting"
      goto 1000
    endif

    
    pr1_TESTVOID = GetProcAddress(pDLL, "TESTVOID"C)
    if (pr1_TESTVOID == 0) then
      type *, "Error occurred finding _TestVoid in CplusplusDLL.dll"
      type *, "Program aborting"
      goto 1000
    endif

    call TESTVOID()
    print *, 'Hello World MeinTest'

    pr1_TestInteger = GetProcAddress(pDLL, "TestInteger"C)
    if (pr1_TestInteger == 0) then
      type *, "Error occurred finding _TestVoid in CplusplusDLL.dll"
      type *, "Program aborting"
      goto 1000
    endif

    Inty1 = -999
    Inty2 = 999
    Inty1 =  TestInteger_FORTRAN(Inty2)
    
    pr1_TestInteger_Rueckgabe = GetProcAddress(pDLL, "TestInteger_Rueckgabe"C)
    if (pr1_TestInteger_Rueckgabe == 0) then
      type *, "Error occurred finding _TestVoid in CplusplusDLL.dll"
      type *, "Program aborting"
      goto 1000
    endif

    Inty1 = -999
    Inty2 = 999
    Inty1 =  TestInteger_Rueckgabe(Inty2)


    pr1_TestChar = GetProcAddress(pDLL, "TestChar"C)
    if (pr1_TestChar == 0) then
      type *, "Error occurred finding _TestVoid in CplusplusDLL.dll"
      type *, "Program aborting"
      goto 1000
    endif

    Inty1 = -999

    charly = "HUHU C++"C
    Inty1 =  TestChar(charly)
    
    pr1_TestDouble = GetProcAddress(pDLL, "TestDouble"C)
    if (pr1_TestDouble == 0) then
      type *, "Error occurred finding _TestVoid in CplusplusDLL.dll"
      type *, "Program aborting"
      goto 1000
    endif

    Inty1 = -999
    doubly = 9.876
    Inty1 =  TestDouble(doubly)
    
    pr1_TestFloat = GetProcAddress(pDLL, "TestFloat"C)
    if (pr1_TestFloat == 0) then
      type *, "Error occurred finding _TestVoid in CplusplusDLL.dll"
      type *, "Program aborting"
      goto 1000
    endif

    Inty1 = -999
    realy = 9.876
    Inty1 =  TestFloat(realy)
    
        

      ! Release library
      status = freelibrary(pDLL)
            
1000    end subroutine meinTest
         
      END MODULE Schnittstelle2C
      
